    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.security.MessageDigest

    java.lang.Object
       |
       +----java.security.MessageDigest

public abstract class MessageDigest
extends Object

This MessageDigest class provides the functionality of a message digest algorithm, such as MD5 or SHA. Message digests are secure one-way hash functions that take arbitrary-sized data and output a fixed-length hash value.

Like other algorithm-based classes in Java Security, MessageDigest has two major components:

Message Digest API (Application Program Interface)
  This is the interface of methods called by applications needing message digest services. The API consists of all public methods.
Message Digest SPI (Service Provider Interface)
  This is the interface implemented by providers that supply specific algorithms. It consists of all methods whose names are prefixed by engine. Each such method is called by a correspondingly-named public API method. For example, the `engineReset` method is called by the `reset` method. The SPI methods are abstract; providers must supply a concrete implementation.

A MessageDigest object starts out initialized. The data is processed through it using the update methods. At any point reset can be called to reset the digest. Once all the data to be updated has been updated, one of the digest methods should be called to complete the hash computation.

The `digest` method can be called once for a given number of updates. After `digest` has been called, the MessageDigest object is reset to its initialized state.

Implementations are free to implement the Cloneable interface, and doing so will let client applications test cloneability using `instanceof Cloneable` before cloning:

     MessageDigest md = MessageDigest.getInstance("SHA");
     if (md instanceof Cloneable) {
         md.update(toChapter1);
         MessageDigest tc1 = md.clone();
         byte[] toChapter1Digest = tc1.digest;
         md.update(toChapter2);
         ...etc.
     } else {
         throw new DigestException("couldn't make digest of partial content");
     }

Note that if a given implementation is not cloneable, it is still possible to compute intermediate digests by instantiating several instances, if the number of digests is known in advance.

See Also:
  DigestInputStream, DigestOutputStream

##

MessageDigest(String)
  Creates a message digest with the specified algorithm name.

##

clone()
  Returns a clone if the implementation is cloneable.
digest()
  Completes the hash computation by performing final operations such as padding.
digest(byte[])
  Performs a final update on the digest using the specified array of bytes, then completes the digest computation.
engineDigest()
  SPI: Completes the hash computation by performing final operations such as padding.
engineReset()
  SPI: Resets the digest for further use.
engineUpdate(byte)
  SPI: Updates the digest using the specified byte.
engineUpdate(byte[], int, int)
  SPI: Updates the digest using the specified array of bytes, starting at the specified offset.
getAlgorithm()
  Returns a string that identifies the algorithm, independent of implementation details.
getInstance(String)
  Generates a MessageDigest object that implements the specified digest algorithm.
getInstance(String, String)
  Generates a MessageDigest object implementing the specified algorithm, as supplied from the specified provider, if such an algorithm is available from the provider.
isEqual(byte[], byte[])
  Compares two digests for equality.
reset()
  Resets the digest for further use.
toString()
  Returns a string representation of this message digest object.
update(byte)
  Updates the digest using the specified byte.
update(byte[])
  Updates the digest using the specified array of bytes.
update(byte[], int, int)
  Updates the digest using the specified array of bytes, starting at the specified offset.

##

MessageDigest

     protected MessageDigest(String algorithm)

  Creates a message digest with the specified algorithm name.

  Parameters:
    algorithm - the standard name of the digest algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.

##

getInstance

     public static MessageDigest getInstance(String algorithm) throws NoSuchAlgorithmException

  Generates a MessageDigest object that implements the specified digest algorithm. If the default provider package contains a MessageDigest subclass implementing the algorithm, an instance of that subclass is returned. If the algorithm is not available in the default package, other packages are searched.

  Parameters:
    algorithm - the name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
  Returns:
    a Message Digest object implementing the specified algorithm.
  Throws: NoSuchAlgorithmException
    if the algorithm is not available in the caller's environment.

getInstance

     public static MessageDigest getInstance(String algorithm,
                                             String provider) throws NoSuchAlgorithmException, NoSuchProviderException

  Generates a MessageDigest object implementing the specified algorithm, as supplied from the specified provider, if such an algorithm is available from the provider.

  Parameters:
    algorithm - the name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    provider - the name of the provider.
  Returns:
    a Message Digest object implementing the specified algorithm.
  Throws: NoSuchAlgorithmException
    if the algorithm is not available in the package supplied by the requested provider.
  Throws: NoSuchProviderException
    if the provider is not available in the environment.
  See Also:
    Provider

update

     public void update(byte input)

  Updates the digest using the specified byte.

  Parameters:
    input - the byte with which to update the digest.

update

     public void update(byte input[],
                        int offset,
                        int len)

  Updates the digest using the specified array of bytes, starting at the specified offset.

  Parameters:
    input - the array of bytes.
    offset - the offset to start from in the array of bytes.
    len - the number of bytes to use, starting at `offset`.

update

     public void update(byte input[])

  Updates the digest using the specified array of bytes.

  Parameters:
    input - the array of bytes.

digest

     public byte[] digest()

  Completes the hash computation by performing final operations such as padding. The digest is reset after this call is made.

  Returns:
    the array of bytes for the resulting hash value.

digest

     public byte[] digest(byte input[])

  Performs a final update on the digest using the specified array of bytes, then completes the digest computation. That is, this method first calls update on the array, then calls digest().

  Parameters:
    input - the input to be updated before the digest is completed.
  Returns:
    the array of bytes for the resulting hash value.

toString

     public String toString()

  Returns a string representation of this message digest object.

  Overrides:
    toString in class Object

isEqual

     public static boolean isEqual(byte digesta[],
                                   byte digestb[])

  Compares two digests for equality. Does a simple byte compare.

  Parameters:
    digesta - one of the digests to compare.
    digestb - the other digest to compare.
  Returns:
    true if the digests are equal, false otherwise.

reset

     public void reset()

  Resets the digest for further use.

getAlgorithm

     public final String getAlgorithm()

  Returns a string that identifies the algorithm, independent of implementation details. The name should be a standard Java Security name (such as "SHA", "MD5", and so on). See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.

engineUpdate

     protected abstract void engineUpdate(byte input)

  SPI: Updates the digest using the specified byte.

  Parameters:
    input - the byte to use for the update.

engineUpdate

     protected abstract void engineUpdate(byte input[],
                                          int offset,
                                          int len)

  SPI: Updates the digest using the specified array of bytes, starting at the specified offset. This should be a no-op if the digest has been finalized.

  Parameters:
    input - the array of bytes to use for the update.
    offset - the offset to start from in the array of bytes.
    len - the number of bytes to use, starting at `offset`.

engineDigest

     protected abstract byte[] engineDigest()

  SPI: Completes the hash computation by performing final operations such as padding. Once `engineDigest` has been called, the engine should be reset (see reset). Resetting is the responsibility of the engine implementor.

  Returns:
    the array of bytes for the resulting hash value.

engineReset

     protected abstract void engineReset()

  SPI: Resets the digest for further use.

clone

     public Object clone() throws CloneNotSupportedException

  Returns a clone if the implementation is cloneable.

  Returns:
    a clone if the implementation is cloneable.
  Throws: CloneNotSupportedException
    if this is called on an implementation that does not support `Cloneable`.
  Overrides:
    clone in class Object

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.